## stubble 4

=== Makefile ===
# SPDX-License-Identifier: LGPL-2.1-or-later

include ./Make.defaults

ARCH?=		$(shell uname -m)
PREFIX?=	/usr

ifeq ($(ARCH),x86_64)
	CFLAGS += -m64 -march=x86-64 -mno-red-zone -mgeneral-regs-only -maccumulate-outgoing-args
	LDFLAGS += -m64
endif
ifeq ($(ARCH),aarch64)
	CFLAGS += -mgeneral-regs-only
endif

OBJS = devicetree.o efi-log.o efi-string.o linux.o stub.o util.o uki.o smbios.o initrd.o pe.o \
	chid.o edid.o sha1.o measure.o

.PHONY: all clean install

all: stubble.efi

%.o: %.c
	$(CC) $< $(CFLAGS) -c -o $@

stubble.efi: stubble
	./elf2efi.py --version-major=6 --version-minor=16 \
	    --efi-major=1 --efi-minor=1 --subsystem=10 \
	    --minimum-sections=50 \
	    --copy-sections=".sbat" $< $@

stubble: $(OBJS)
	$(CC) -o $@ $^ $(LDFLAGS)

install: stubble.efi
	install -m 755 -d ${DESTDIR}${PREFIX}/lib/stubble
	install -m 644 -t ${DESTDIR}${PREFIX}/lib/stubble stubble.efi
	install -m 755 -d ${DESTDIR}${PREFIX}/share/stubble/hwids
	install -m 644 -t ${DESTDIR}${PREFIX}/share/stubble/hwids hwids/json/*

clean:
	rm -f $(OBJS)
	rm -f stubble
	rm -f stubble.efi

## stubble 2

=== debian/changelog ===
stubble (2-1) questing; urgency=medium

  [ Tobias Heider ]
  * Revert "Revert recent shim16 fixes"
  * Remove load_via_boot_services() and resulting dead code

  [ Mate Kukri ]
  * Load Linux kernel the same way GRUB would
  * delete unused code and systemd features we do not require
  * re-add command line measurement to PCR12
  * remove loaded image protocol uninstallation that is no longer required

  [ Tobias Heider ]
  * Remove unused includes and headers
  * Remove "Priority: important" which was added by accident
  * Add sbat template filled in with versions at build time
  * Add back RNG for stack-protector
  * Rename s/ubustub/stubble/ (LP: #2120200)

 -- Tobias Heider <tobias.heider@canonical.com>  Fri, 08 Aug 2025 19:34:45 +0200

ubustub (1-2) questing; urgency=medium

  * d/control: limit to amd64 and arm64 for now
  * d/copyright: separate entry for debian/* as requested by review

 -- Tobias Heider <tobias.heider@canonical.com>  Mon, 04 Aug 2025 14:39:15 +0200

ubustub (1-1) questing; urgency=medium

  * Initial release. (LP: #2119319)

 -- Tobias Heider <tobias.heider@canonical.com>  Fri, 01 Aug 2025 17:22:51 +0200

=== debian/control ===
Source: stubble
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Standards-Version: 4.7.2
Rules-Requires-Root: no
Vcs-Git: https://github.com/canonical/stubble
Vcs-Browser: https://github.com/canonical/stubble.git
Homepage: https://github.com/canonical/stubble
Build-Depends: debhelper-compat (=13),
               python3-pyelftools

Package: stubble
Architecture: amd64 arm64
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: systemd-ukify
Description: UEFI kernel stub with device-tree loading capability
 Small Linux kernel EFI boot stub bundling device trees, a CHID database
 and the kernel. The stub finds a matching device tree based on CHIDs
 generated from SMBIOS and loads it before executing the embedded kernel.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

%:
	dh $@

override_dh_clean:
	dh_clean
	sed -e "s,@UBUNTU_VERSION@,$(DEB_VERSION)," \
	    -e "s,@UPSTREAM_VERSION@,$(DEB_VERSION_UPSTREAM)," \
	    debian/sbat.in > debian/sbat

## stubble 3

=== debian/changelog ===
stubble (3-1) unstable; urgency=medium

  * Initial release. (Closes: #1112063)

 -- Christopher Obbard <obbardc@debian.org>  Mon, 25 Aug 2025 20:30:42 +0100

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: stubble
 Section: admin
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+Maintainer: Tobias Heider <tobias.heider@canonical.com>
+Uploaders: Christopher Obbard <obbardc@debian.org>
 Standards-Version: 4.7.2
 Rules-Requires-Root: no
-Vcs-Git: https://github.com/canonical/stubble
-Vcs-Browser: https://github.com/canonical/stubble.git
+Vcs-Git: https://salsa.debian.org/debian/stubble
+Vcs-Browser: https://salsa.debian.org/debian/stubble.git
 Homepage: https://github.com/canonical/stubble
 Build-Depends: debhelper-compat (=13),
                python3-pyelftools

## stubble 4

=== debian/changelog ===
stubble (4-0ubuntu2) questing; urgency=low

  * stubble-kernel support with dynamic dtbs.

 -- Andy Whitcroft <apw@canonical.com>  Fri, 19 Sep 2025 14:03:47 +0100

stubble (4-0ubuntu1) questing; urgency=medium

  * New upstream version v4
    - Add new HWIDS:
      + ThinkPad T14s LCD touchscreen panel (BOE0c26)
      + Thinkpad T14s OLED panel (SDC419f)
      + x1e80100-hp-elitebook-ultra-g1q
    - hwids: T14s: default to LCD dtb if no EDID info is matching
    - Upstream moved to ubuntu/stubble
    - Add finddtbs.py helper script to find dtbs based on hwids/json

  * New upstream version v3
    - Added new HWIDs:
       + x1e78100-lenovo-thinkpad-t14s (lcd/oled)
       + x1e80100-asus-zenbook-a14 (lcd/oled)
       + x1e80100-dell-inspiron-14-plus-7441
       + x1e80100-microsoft-denali
       + x1e80100-microsoft-romulus13
       + x1e80100-microsoft-romulus15
       + x1p42100-hp-omnibook-x14
       + x1p64100-acer-swift-sf14-11
    - Fixed linux loader path
    - Don't falsely mark stubble.elf NX compatible
    - Changed default behaviour when a dtb is already loaded to find a matching
      embedded dtb by "compatible". This can be changed with the new
      stubble.dtb_override=bool command line option

 -- Tobias Heider <tobias.heider@canonical.com>  Thu, 04 Sep 2025 11:59:17 +0200

=== debian/control ===
Source: stubble
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Standards-Version: 4.7.2
Rules-Requires-Root: no
Vcs-Git: https://github.com/ubuntu/stubble
Vcs-Browser: https://github.com/ubuntu/stubble.git
Homepage: https://github.com/ubuntu/stubble
Build-Depends: debhelper-compat (=13),
               python3-pyelftools

Package: stubble
Architecture: amd64 arm64
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: systemd-ukify
Description: UEFI kernel stub with device-tree loading capability
 Small Linux kernel EFI boot stub bundling device trees, a CHID database
 and the kernel. The stub finds a matching device tree based on CHIDs
 generated from SMBIOS and loads it before executing the embedded kernel.

Package: stubble-kernel
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}, stubble, systemd-ukify, python3-libfdt
Description: UEFI kernel stub with device-tree loading capability -- kernel helper
 Small Linux kernel EFI boot stub bundling device trees, a CHID database
 and the kernel. The stub finds a matching device tree based on CHIDs
 generated from SMBIOS and loads it before executing the embedded kernel.
 Helper for the kernel to generate the stubble kernels.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

%:
	dh $@

override_dh_clean:
	dh_clean
	sed -e "s,@DEBIAN_VERSION@,$(DEB_VERSION)," \
	    -e "s,@UPSTREAM_VERSION@,$(DEB_VERSION_UPSTREAM)," \
	    debian/sbat.in > debian/sbat

## stubble 6

=== debian/changelog ===
stubble (6-0ubuntu1) resolute; urgency=medium

  [ Juerg Haefliger ]
  * hwids: Add LENOVO ThinkPad X13s Gen 1 4810QL0100
  * hwid2json.py: Add a trailing newline to the output files

  [ Jens Glathe ]
  * hwids: add Acer Swift Go 14 AI
  * hwids: add ASUS Vivobook S15 x1p42100 variant
  * hwids: add Lenovo Ideapad 5 2in1 14Q8X9
  * hwids: add Lenovo Ideapad 5 Slim5x 14q8x9
  * hwids: Lenovo Ideapad Slim 5: distinguish between OLED and LCD model
  * hwids: add Lenovo Thinkbook 16 G7 QOY
  * hwids: add Microsoft Surface Pro 12"

  [ James Addison ]
  * hwids: Add Medion SPRCHRGD 14 S1 Elite

  [ npnh2 ]
  * hwids: Add Acer Swift 14 Go Pro AI (SFA14-11)
  * hwids: Add Acer Swift 14 Go Pro AI compatible

  [ Tobias Heider ]
  * hwids: Regenerate jsons
  * Add helper script to generate hwids
  * Reference new hwids/hwids.py script in README
  * Fix EDID and move parsing to separate function
  * Fix duplicate code from previous commit
  * Make sure UUIDs are unique for each file
  * Move level to back to fix hwid2json.py
  * Add microsoft,denali-oled dump from Jérôme de Bretagne
  * parse_cmdline: cmdline can be NULL, don't fail hard

 -- Tobias Heider <tobias.heider@canonical.com>  Fri, 23 Jan 2026 21:42:59 +0100

stubble (4-0ubuntu3) resolute; urgency=medium

  * stubble: omit .osrel section from kernel image (LP: #2133402)

 -- Nick Rosbrook <enr0n@ubuntu.com>  Mon, 12 Jan 2026 09:25:46 -0500

## stubble 7

=== Makefile ===
--- 
+++ 
@@ -1,9 +1,10 @@
 # SPDX-License-Identifier: LGPL-2.1-or-later
 
+ARCH?=		$(shell uname -m)
+PREFIX?=	/usr/local
+MIN_SECTIONS?=2048
+
 include ./Make.defaults
-
-ARCH?=		$(shell uname -m)
-PREFIX?=	/usr
 
 ifeq ($(ARCH),x86_64)
 	CFLAGS += -m64 -march=x86-64 -mno-red-zone -mgeneral-regs-only -maccumulate-outgoing-args
@@ -26,7 +27,7 @@
 stubble.efi: stubble
 	./elf2efi.py --version-major=6 --version-minor=16 \
 	    --efi-major=1 --efi-minor=1 --subsystem=10 \
-	    --minimum-sections=50 \
+	    --minimum-sections=${MIN_SECTIONS} \
 	    --copy-sections=".sbat" $< $@
 
 stubble: $(OBJS)

=== debian/changelog ===
stubble (7-2) unstable; urgency=medium

  * Ship finddtbs.py, declare conflict with stubble-kernel from Ubuntu

 -- Tobias Heider <tobias.heider@canonical.com>  Mon, 09 Feb 2026 13:22:35 +0100

stubble (7-1) unstable; urgency=medium

  [ Nino ]
  * Add EDID for touchscreen ThinkPad T14s Gen 6 21N1000RMH

  [ Tobias Heider ]
  * hwid: Add extra T14s OLED hwids from obbardc
  * hwids: T14s: default to lcd dtb if no EDID info is matching
  * hwid: Add HP EliteBook Ultra G1q
  * Add microsoft,denali-oled dump from Jérôme de Bretagne
  * parse_cmdline: cmdline can be NULL, don't fail hard
  * Makefile: Default to /usr/local PREFIX to not conflict with package
  * stubble changed the default prefix to /usr/local so explicitly set /usr
  * upstream moved from canonical/stubble to ubuntu/stubble
  * Enable riscv64 which should work with the latest release

  [ Juerg Haefliger ]
  * hwids: Add LENOVO ThinkPad X13s Gen 1 4810QL0100
  * hwid2json.py: Add a trailing newline to the output files

  [ Jens Glathe ]
  * hwids: add Acer Swift Go 14 AI
  * hwids: add ASUS Vivobook S15 x1p42100 variant
  * hwids: add Lenovo Ideapad 5 2in1 14Q8X9
  * hwids: add Lenovo Ideapad 5 Slim5x 14q8x9
  * hwids: Lenovo Ideapad Slim 5: distinguish between OLED and LCD model
  * hwids: add Lenovo Thinkbook 16 G7 QOY
  * hwids: add Microsoft Surface Pro 12"

  [ James Addison ]
  * hwids: Add Medion SPRCHRGD 14 S1 Elite

  [ npnh2 ]
  * hwids: Add Acer Swift 14 Go Pro AI (SFA14-11)
  * hwids: Add Acer Swift 14 Go Pro AI compatible

  [ Heinrich Schuchardt ]
  * Make.defaults: correct build flags for riscv64
  * Makefile: raise minimum number of sections

  [ Wei-Lin Chang ]
  * efi-log: Call ourselves stubble

 -- Tobias Heider <tobias.heider@canonical.com>  Thu, 05 Feb 2026 13:31:40 +0100

=== debian/control ===
Source: stubble
Section: admin
Priority: optional
Maintainer: Tobias Heider <tobias.heider@canonical.com>
Uploaders: Christopher Obbard <obbardc@debian.org>
Standards-Version: 4.7.2
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/debian/stubble
Vcs-Browser: https://salsa.debian.org/debian/stubble.git
Homepage: https://github.com/ubuntu/stubble
Build-Depends: debhelper-compat (=13),
               python3-pyelftools

Package: stubble
Architecture: amd64 arm64 riscv64
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}, python3-libfdt
Conflicts: stubble-kernel (<< 7-1)
Suggests: systemd-ukify
Description: UEFI kernel stub with device-tree loading capability
 Small Linux kernel EFI boot stub bundling device trees, a CHID database
 and the kernel. The stub finds a matching device tree based on CHIDs
 generated from SMBIOS and loads it before executing the embedded kernel.

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 include /usr/share/dpkg/pkg-info.mk
 
 %:
-	dh $@
+	PREFIX=/usr dh $@
 
 override_dh_clean:
 	dh_clean
